// *********************************************************
//
// File autogenerated for the force_torque_sensor package
// by the rosparam_handler package.
// Please do not edit.
//
// ********************************************************/

#pragma once

#include <ros/param.h>
#include <ros/node_handle.h>
#include <rosparam_handler/utilities.hpp>
#ifdef DYNAMIC_RECONFIGURE_FOUND
#include <force_torque_sensor/CalibrationConfig.h>
#else
struct CalibrationConfig{};
#endif


namespace force_torque_sensor {

/// \brief Parameter struct generated by rosparam_handler
struct CalibrationParameters {

  using Config = CalibrationConfig;

  CalibrationParameters(const ros::NodeHandle& private_node_handle)
  : globalNamespace{"/"},
    privateNamespace{private_node_handle.getNamespace() + "/"},
    nodeName{rosparam_handler::getNodeName(private_node_handle)} {}

  /// \brief Get values from parameter server
  /// 
  /// Will fail if a value can not be found and no default value is given.
  void fromParamServer(){
    bool success = true;
    success &= rosparam_handler::getParam(privateNamespace + "n_measurements", n_measurements, int{100});
    success &= rosparam_handler::getParam(privateNamespace + "T_between_meas", T_between_meas, double{0.1});
    success &= rosparam_handler::getParam(privateNamespace + "isStatic", isStatic, bool{false});
    success &= rosparam_handler::getParam(privateNamespace + "force", force, std::map<std::string,double>{{"y",0.0},{"x",0.0},{"z",0.0}});
    success &= rosparam_handler::getParam(privateNamespace + "torque", torque, std::map<std::string,double>{{"y",0.0},{"x",0.0},{"z",0.0}});

    if(!success){
      missingParamsWarning();
      rosparam_handler::exit("RosparamHandler: GetParam could net retrieve parameter.");
    }
    ROS_DEBUG_STREAM(*this);
  }

  /// \brief Set parameters on ROS parameter server.
  void toParamServer(){
  rosparam_handler::setParam(privateNamespace + "n_measurements",n_measurements);
  rosparam_handler::setParam(privateNamespace + "T_between_meas",T_between_meas);
  rosparam_handler::setParam(privateNamespace + "isStatic",isStatic);
  rosparam_handler::setParam(privateNamespace + "force",force);
  rosparam_handler::setParam(privateNamespace + "torque",torque);        
  }

  /// \brief Update configurable parameters.
  ///
  /// \param config  dynamic reconfigure struct
  /// \level ?
  void fromConfig(const Config& config, const uint32_t level = 0){
#ifdef DYNAMIC_RECONFIGURE_FOUND
    n_measurements = config.n_measurements;
    T_between_meas = config.T_between_meas;
    isStatic = config.isStatic;
#else
  ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
  rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  void toConfig(Config& config){
#ifdef DYNAMIC_RECONFIGURE_FOUND
       config.n_measurements = n_measurements;
   config.T_between_meas = T_between_meas;
   config.isStatic = isStatic;
#else
      ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
      rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  /// \brief Stream operator for printing parameter struct
  friend std::ostream& operator<<(std::ostream& os, const CalibrationParameters& p)
  {
    os << "[" << p.nodeName << "]\nNode " << p.nodeName << " has the following parameters:\n"
      << "	" << p.privateNamespace << "n_measurements:" << p.n_measurements << "\n"
      << "	" << p.privateNamespace << "T_between_meas:" << p.T_between_meas << "\n"
      << "	" << p.privateNamespace << "isStatic:" << p.isStatic << "\n"
      << "	" << p.privateNamespace << "force:" << rosparam_handler::to_string(p.force) << "\n"
      << "	" << p.privateNamespace << "torque:" << rosparam_handler::to_string(p.torque) << "\n"
;
    return os;
  }

    int n_measurements; /*!< number of necessary measurements for calibration */
  double T_between_meas; /*!< time between two measurements for calibration */
  bool isStatic; /*!< is static calibration active */
  std::map<std::string,double> force; /*!< calibration offset vector force */
  std::map<std::string,double> torque; /*!< calibration offset vector torque */

private:
  /// \brief Issue a warning about missing default parameters.
  void missingParamsWarning(){
    ROS_WARN_STREAM("[" << nodeName << "]\nThe following parameters do not have default values and need to be specified:\n"
    );
  }

  const std::string globalNamespace;
  const std::string privateNamespace;
  const std::string nodeName;
};

} // namespace force_torque_sensor
