// *********************************************************
//
// File autogenerated for the force_torque_sensor package
// by the rosparam_handler package.
// Please do not edit.
//
// ********************************************************/

#pragma once

#include <ros/param.h>
#include <ros/node_handle.h>
#include <rosparam_handler/utilities.hpp>
#ifdef DYNAMIC_RECONFIGURE_FOUND
#include <force_torque_sensor/CoordinateSystemCalibrationConfig.h>
#else
struct CoordinateSystemCalibrationConfig{};
#endif


namespace force_torque_sensor {

/// \brief Parameter struct generated by rosparam_handler
struct CoordinateSystemCalibrationParameters {

  using Config = CoordinateSystemCalibrationConfig;

  CoordinateSystemCalibrationParameters(const ros::NodeHandle& private_node_handle)
  : globalNamespace{"/"},
    privateNamespace{private_node_handle.getNamespace() + "/"},
    nodeName{rosparam_handler::getNodeName(private_node_handle)} {}

  /// \brief Get values from parameter server
  /// 
  /// Will fail if a value can not be found and no default value is given.
  void fromParamServer(){
    bool success = true;
    success &= rosparam_handler::getParam(privateNamespace + "n_measurements", n_measurements, int{0});
    success &= rosparam_handler::getParam(privateNamespace + "T_between_meas", T_between_meas, int{0});
    success &= rosparam_handler::getParam(privateNamespace + "push_direction", push_direction, int{0});

    if(!success){
      missingParamsWarning();
      rosparam_handler::exit("RosparamHandler: GetParam could net retrieve parameter.");
    }
    ROS_DEBUG_STREAM(*this);
  }

  /// \brief Set parameters on ROS parameter server.
  void toParamServer(){
  rosparam_handler::setParam(privateNamespace + "n_measurements",n_measurements);
  rosparam_handler::setParam(privateNamespace + "T_between_meas",T_between_meas);
  rosparam_handler::setParam(privateNamespace + "push_direction",push_direction);        
  }

  /// \brief Update configurable parameters.
  ///
  /// \param config  dynamic reconfigure struct
  /// \level ?
  void fromConfig(const Config& config, const uint32_t level = 0){
#ifdef DYNAMIC_RECONFIGURE_FOUND
    n_measurements = config.n_measurements;
    T_between_meas = config.T_between_meas;
#else
  ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
  rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  void toConfig(Config& config){
#ifdef DYNAMIC_RECONFIGURE_FOUND
       config.n_measurements = n_measurements;
   config.T_between_meas = T_between_meas;
#else
      ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
      rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  /// \brief Stream operator for printing parameter struct
  friend std::ostream& operator<<(std::ostream& os, const CoordinateSystemCalibrationParameters& p)
  {
    os << "[" << p.nodeName << "]\nNode " << p.nodeName << " has the following parameters:\n"
      << "	" << p.privateNamespace << "n_measurements:" << p.n_measurements << "\n"
      << "	" << p.privateNamespace << "T_between_meas:" << p.T_between_meas << "\n"
      << "	" << p.privateNamespace << "push_direction:" << p.push_direction << "\n"
;
    return os;
  }

    int n_measurements; /*!< number of necessary measurements for calibration */
  int T_between_meas; /*!< time between two measurements for calibration */
  int push_direction; /*!< push direction */

private:
  /// \brief Issue a warning about missing default parameters.
  void missingParamsWarning(){
    ROS_WARN_STREAM("[" << nodeName << "]\nThe following parameters do not have default values and need to be specified:\n"
    );
  }

  const std::string globalNamespace;
  const std::string privateNamespace;
  const std::string nodeName;
};

} // namespace force_torque_sensor
