// *********************************************************
//
// File autogenerated for the force_torque_sensor package
// by the rosparam_handler package.
// Please do not edit.
//
// ********************************************************/

#pragma once

#include <ros/param.h>
#include <ros/node_handle.h>
#include <rosparam_handler/utilities.hpp>
#ifdef DYNAMIC_RECONFIGURE_FOUND
#include <force_torque_sensor/HWCommunicationConfigurationConfig.h>
#else
struct HWCommunicationConfigurationConfig{};
#endif


namespace force_torque_sensor {

/// \brief Parameter struct generated by rosparam_handler
struct HWCommunicationConfigurationParameters {

  using Config = HWCommunicationConfigurationConfig;

  HWCommunicationConfigurationParameters(const ros::NodeHandle& private_node_handle)
  : globalNamespace{"/"},
    privateNamespace{private_node_handle.getNamespace() + "/"},
    nodeName{rosparam_handler::getNodeName(private_node_handle)} {}

  /// \brief Get values from parameter server
  /// 
  /// Will fail if a value can not be found and no default value is given.
  void fromParamServer(){
    bool success = true;
    success &= rosparam_handler::getParam(privateNamespace + "type", type, int{-1});
    success &= rosparam_handler::getParam(privateNamespace + "path", path, std::string{" "});
    success &= rosparam_handler::getParam(privateNamespace + "baudrate", baudrate, int{-1});

    if(!success){
      missingParamsWarning();
      rosparam_handler::exit("RosparamHandler: GetParam could net retrieve parameter.");
    }
    ROS_DEBUG_STREAM(*this);
  }

  /// \brief Set parameters on ROS parameter server.
  void toParamServer(){
  rosparam_handler::setParam(privateNamespace + "type",type);
  rosparam_handler::setParam(privateNamespace + "path",path);
  rosparam_handler::setParam(privateNamespace + "baudrate",baudrate);        
  }

  /// \brief Update configurable parameters.
  ///
  /// \param config  dynamic reconfigure struct
  /// \level ?
  void fromConfig(const Config& config, const uint32_t level = 0){
#ifdef DYNAMIC_RECONFIGURE_FOUND

#else
  ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
  rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  void toConfig(Config& config){
#ifdef DYNAMIC_RECONFIGURE_FOUND
    
#else
      ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
      rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  /// \brief Stream operator for printing parameter struct
  friend std::ostream& operator<<(std::ostream& os, const HWCommunicationConfigurationParameters& p)
  {
    os << "[" << p.nodeName << "]\nNode " << p.nodeName << " has the following parameters:\n"
      << "	" << p.privateNamespace << "type:" << p.type << "\n"
      << "	" << p.privateNamespace << "path:" << p.path << "\n"
      << "	" << p.privateNamespace << "baudrate:" << p.baudrate << "\n"
;
    return os;
  }

    int type; /*!< communication type; important for CAN */
  std::string path; /*!< path */
  int baudrate; /*!< baudrate */

private:
  /// \brief Issue a warning about missing default parameters.
  void missingParamsWarning(){
    ROS_WARN_STREAM("[" << nodeName << "]\nThe following parameters do not have default values and need to be specified:\n"
    );
  }

  const std::string globalNamespace;
  const std::string privateNamespace;
  const std::string nodeName;
};

} // namespace force_torque_sensor
