// *********************************************************
//
// File autogenerated for the force_torque_sensor package
// by the rosparam_handler package.
// Please do not edit.
//
// ********************************************************/

#pragma once

#include <ros/param.h>
#include <ros/node_handle.h>
#include <rosparam_handler/utilities.hpp>
#ifdef DYNAMIC_RECONFIGURE_FOUND
#include <force_torque_sensor/NodeConfigurationConfig.h>
#else
struct NodeConfigurationConfig{};
#endif


namespace force_torque_sensor {

/// \brief Parameter struct generated by rosparam_handler
struct NodeConfigurationParameters {

  using Config = NodeConfigurationConfig;

  NodeConfigurationParameters(const ros::NodeHandle& private_node_handle)
  : globalNamespace{"/"},
    privateNamespace{private_node_handle.getNamespace() + "/"},
    nodeName{rosparam_handler::getNodeName(private_node_handle)} {}

  /// \brief Get values from parameter server
  /// 
  /// Will fail if a value can not be found and no default value is given.
  void fromParamServer(){
    bool success = true;
    success &= rosparam_handler::getParam(privateNamespace + "sim", sim, bool{false});
    success &= rosparam_handler::getParam(privateNamespace + "sensor_hw", sensor_hw, std::string{"force_torque_sensor/ForceTorqueSensorSim"});
    success &= rosparam_handler::getParam(privateNamespace + "ft_pub_freq", ft_pub_freq, double{200});
    success &= rosparam_handler::getParam(privateNamespace + "ft_pull_freq", ft_pull_freq, double{800});
    success &= rosparam_handler::getParam(privateNamespace + "transform_frame", transform_frame, std::string{"fts_transform_frame"});
    success &= rosparam_handler::getParam(privateNamespace + "static_application", static_application, bool{false});
    success &= rosparam_handler::getParam(privateNamespace + "sensor_frame", sensor_frame, std::string{"fts_reference_link"});

    if(!success){
      missingParamsWarning();
      rosparam_handler::exit("RosparamHandler: GetParam could net retrieve parameter.");
    }
    ROS_DEBUG_STREAM(*this);
  }

  /// \brief Set parameters on ROS parameter server.
  void toParamServer(){
  rosparam_handler::setParam(privateNamespace + "sim",sim);
  rosparam_handler::setParam(privateNamespace + "sensor_hw",sensor_hw);
  rosparam_handler::setParam(privateNamespace + "ft_pub_freq",ft_pub_freq);
  rosparam_handler::setParam(privateNamespace + "ft_pull_freq",ft_pull_freq);
  rosparam_handler::setParam(privateNamespace + "transform_frame",transform_frame);
  rosparam_handler::setParam(privateNamespace + "static_application",static_application);
  rosparam_handler::setParam(privateNamespace + "sensor_frame",sensor_frame);        
  }

  /// \brief Update configurable parameters.
  ///
  /// \param config  dynamic reconfigure struct
  /// \level ?
  void fromConfig(const Config& config, const uint32_t level = 0){
#ifdef DYNAMIC_RECONFIGURE_FOUND

#else
  ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
  rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  void toConfig(Config& config){
#ifdef DYNAMIC_RECONFIGURE_FOUND
    
#else
      ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
      rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  /// \brief Stream operator for printing parameter struct
  friend std::ostream& operator<<(std::ostream& os, const NodeConfigurationParameters& p)
  {
    os << "[" << p.nodeName << "]\nNode " << p.nodeName << " has the following parameters:\n"
      << "	" << p.privateNamespace << "sim:" << p.sim << "\n"
      << "	" << p.privateNamespace << "sensor_hw:" << p.sensor_hw << "\n"
      << "	" << p.privateNamespace << "ft_pub_freq:" << p.ft_pub_freq << "\n"
      << "	" << p.privateNamespace << "ft_pull_freq:" << p.ft_pull_freq << "\n"
      << "	" << p.privateNamespace << "transform_frame:" << p.transform_frame << "\n"
      << "	" << p.privateNamespace << "static_application:" << p.static_application << "\n"
      << "	" << p.privateNamespace << "sensor_frame:" << p.sensor_frame << "\n"
;
    return os;
  }

    bool sim; /*!< if simulation or not */
  std::string sensor_hw; /*!< SensorHW plugin if plugin should be loaded by default. */
  double ft_pub_freq; /*!< publish frequency */
  double ft_pull_freq; /*!< sensor data pull frequency */
  std::string transform_frame; /*!< reference coordinate system */
  bool static_application; /*!< does your FTS change it's position w.r.t. the robot's base (i.e. controller frame) */
  std::string sensor_frame; /*!< sensor coordinate system */

private:
  /// \brief Issue a warning about missing default parameters.
  void missingParamsWarning(){
    ROS_WARN_STREAM("[" << nodeName << "]\nThe following parameters do not have default values and need to be specified:\n"
    );
  }

  const std::string globalNamespace;
  const std::string privateNamespace;
  const std::string nodeName;
};

} // namespace force_torque_sensor
