// *********************************************************
//
// File autogenerated for the force_torque_sensor package
// by the rosparam_handler package.
// Please do not edit.
//
// ********************************************************/

#pragma once

#include <ros/param.h>
#include <ros/node_handle.h>
#include <rosparam_handler/utilities.hpp>
#ifdef DYNAMIC_RECONFIGURE_FOUND
#include <force_torque_sensor/PublishConfigurationConfig.h>
#else
struct PublishConfigurationConfig{};
#endif


namespace force_torque_sensor {

/// \brief Parameter struct generated by rosparam_handler
struct PublishConfigurationParameters {

  using Config = PublishConfigurationConfig;

  PublishConfigurationParameters(const ros::NodeHandle& private_node_handle)
  : globalNamespace{"/"},
    privateNamespace{private_node_handle.getNamespace() + "/"},
    nodeName{rosparam_handler::getNodeName(private_node_handle)} {}

  /// \brief Get values from parameter server
  /// 
  /// Will fail if a value can not be found and no default value is given.
  void fromParamServer(){
    bool success = true;
    success &= rosparam_handler::getParam(privateNamespace + "sensor_data", sensor_data, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "low_pass", low_pass, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "moving_mean", moving_mean, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "transformed_data", transformed_data, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "gravity_compensated", gravity_compensated, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "threshold_filtered", threshold_filtered, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "output_data", output_data, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "iirob_led", iirob_led, bool{true});

    if(!success){
      missingParamsWarning();
      rosparam_handler::exit("RosparamHandler: GetParam could net retrieve parameter.");
    }
    ROS_DEBUG_STREAM(*this);
  }

  /// \brief Set parameters on ROS parameter server.
  void toParamServer(){
  rosparam_handler::setParam(privateNamespace + "sensor_data",sensor_data);
  rosparam_handler::setParam(privateNamespace + "low_pass",low_pass);
  rosparam_handler::setParam(privateNamespace + "moving_mean",moving_mean);
  rosparam_handler::setParam(privateNamespace + "transformed_data",transformed_data);
  rosparam_handler::setParam(privateNamespace + "gravity_compensated",gravity_compensated);
  rosparam_handler::setParam(privateNamespace + "threshold_filtered",threshold_filtered);
  rosparam_handler::setParam(privateNamespace + "output_data",output_data);
  rosparam_handler::setParam(privateNamespace + "iirob_led",iirob_led);        
  }

  /// \brief Update configurable parameters.
  ///
  /// \param config  dynamic reconfigure struct
  /// \level ?
  void fromConfig(const Config& config, const uint32_t level = 0){
#ifdef DYNAMIC_RECONFIGURE_FOUND
    sensor_data = config.sensor_data;
    low_pass = config.low_pass;
    moving_mean = config.moving_mean;
    transformed_data = config.transformed_data;
    gravity_compensated = config.gravity_compensated;
    threshold_filtered = config.threshold_filtered;
    output_data = config.output_data;
    iirob_led = config.iirob_led;
#else
  ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
  rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  void toConfig(Config& config){
#ifdef DYNAMIC_RECONFIGURE_FOUND
       config.sensor_data = sensor_data;
   config.low_pass = low_pass;
   config.moving_mean = moving_mean;
   config.transformed_data = transformed_data;
   config.gravity_compensated = gravity_compensated;
   config.threshold_filtered = threshold_filtered;
   config.output_data = output_data;
   config.iirob_led = iirob_led;
#else
      ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
      rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  /// \brief Stream operator for printing parameter struct
  friend std::ostream& operator<<(std::ostream& os, const PublishConfigurationParameters& p)
  {
    os << "[" << p.nodeName << "]\nNode " << p.nodeName << " has the following parameters:\n"
      << "	" << p.privateNamespace << "sensor_data:" << p.sensor_data << "\n"
      << "	" << p.privateNamespace << "low_pass:" << p.low_pass << "\n"
      << "	" << p.privateNamespace << "moving_mean:" << p.moving_mean << "\n"
      << "	" << p.privateNamespace << "transformed_data:" << p.transformed_data << "\n"
      << "	" << p.privateNamespace << "gravity_compensated:" << p.gravity_compensated << "\n"
      << "	" << p.privateNamespace << "threshold_filtered:" << p.threshold_filtered << "\n"
      << "	" << p.privateNamespace << "output_data:" << p.output_data << "\n"
      << "	" << p.privateNamespace << "iirob_led:" << p.iirob_led << "\n"
;
    return os;
  }

    bool sensor_data; /*!< publsih raw sensor data */
  bool low_pass; /*!< publish low pass filtered data */
  bool moving_mean; /*!< publish moving mean filtered data */
  bool transformed_data; /*!< publish transformed data */
  bool gravity_compensated; /*!< publish gravity compensated data */
  bool threshold_filtered; /*!< publish threshold filtered data */
  bool output_data; /*!< publsih data after all filters */
  bool iirob_led; /*!< publish data for iirob_led */

private:
  /// \brief Issue a warning about missing default parameters.
  void missingParamsWarning(){
    ROS_WARN_STREAM("[" << nodeName << "]\nThe following parameters do not have default values and need to be specified:\n"
    );
  }

  const std::string globalNamespace;
  const std::string privateNamespace;
  const std::string nodeName;
};

} // namespace force_torque_sensor
